<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripReportSummaryResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripReportSummaryResult extends AbstractStructArrayBase
{
    /**
     * The TripReportSummaryResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripReportSummaryResult[]
     */
    public $TripReportSummaryResult;
    /**
     * Constructor method for ArrayOfTripReportSummaryResult
     * @uses ArrayOfTripReportSummaryResult::setTripReportSummaryResult()
     * @param \StructType\TripReportSummaryResult[] $tripReportSummaryResult
     */
    public function __construct(array $tripReportSummaryResult = array())
    {
        $this
            ->setTripReportSummaryResult($tripReportSummaryResult);
    }
    /**
     * Get TripReportSummaryResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripReportSummaryResult[]|null
     */
    public function getTripReportSummaryResult()
    {
        return isset($this->TripReportSummaryResult) ? $this->TripReportSummaryResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTripReportSummaryResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTripReportSummaryResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTripReportSummaryResultForArrayConstraintsFromSetTripReportSummaryResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTripReportSummaryResultTripReportSummaryResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfTripReportSummaryResultTripReportSummaryResultItem instanceof \StructType\TripReportSummaryResult) {
                $invalidValues[] = is_object($arrayOfTripReportSummaryResultTripReportSummaryResultItem) ? get_class($arrayOfTripReportSummaryResultTripReportSummaryResultItem) : sprintf('%s(%s)', gettype($arrayOfTripReportSummaryResultTripReportSummaryResultItem), var_export($arrayOfTripReportSummaryResultTripReportSummaryResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TripReportSummaryResult property can only contain items of type \StructType\TripReportSummaryResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TripReportSummaryResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripReportSummaryResult[] $tripReportSummaryResult
     * @return \ArrayType\ArrayOfTripReportSummaryResult
     */
    public function setTripReportSummaryResult(array $tripReportSummaryResult = array())
    {
        // validation for constraint: array
        if ('' !== ($tripReportSummaryResultArrayErrorMessage = self::validateTripReportSummaryResultForArrayConstraintsFromSetTripReportSummaryResult($tripReportSummaryResult))) {
            throw new \InvalidArgumentException($tripReportSummaryResultArrayErrorMessage, __LINE__);
        }
        if (is_null($tripReportSummaryResult) || (is_array($tripReportSummaryResult) && empty($tripReportSummaryResult))) {
            unset($this->TripReportSummaryResult);
        } else {
            $this->TripReportSummaryResult = $tripReportSummaryResult;
        }
        return $this;
    }
    /**
     * Add item to TripReportSummaryResult value
     * @throws \InvalidArgumentException
     * @param \StructType\TripReportSummaryResult $item
     * @return \ArrayType\ArrayOfTripReportSummaryResult
     */
    public function addToTripReportSummaryResult(\StructType\TripReportSummaryResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripReportSummaryResult) {
            throw new \InvalidArgumentException(sprintf('The TripReportSummaryResult property can only contain items of type \StructType\TripReportSummaryResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TripReportSummaryResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripReportSummaryResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripReportSummaryResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripReportSummaryResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripReportSummaryResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripReportSummaryResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripReportSummaryResult
     */
    public function getAttributeName()
    {
        return 'TripReportSummaryResult';
    }
}
